#========================================================================================
# package      DE_EPAGES::Billsafe::t::TestCommon
# state        public
#----------------------------------------------------------------------------------------
# description  test the _IsAnAllowedClass function, since there are multible LineItemShipping
#               Types like, LineItemShippingDHL, LineItemShippingCollisimo ...
#========================================================================================
package TestCommon;
use strict;

use DE_EPAGES::Core::API::Script qw ( RunScript );
use Test::More;
use DE_EPAGES::Billsafe::API::Common;

sub Main {
    testIsAllowedClass();
    done_testing();
}

sub testIsAllowedClass {
    _positivTests();
    _negativTests();
}
sub _positivTests{
    my @AllowedClasses = qw (
        LineItemProduct
        LineItemDeposit
        LineItemEcoParticipation
        LineItemShippingOption
        LineItemAppointment
        LineItemDiscount
        LineItemPaymentDiscount
        LineItemSalesDiscount
        LineItemGlobalValueDiscount
        LineItemCoupon

        LineItemShippingDHL
        LineItemShippingColissimo
    );
    foreach my $AllowedClasse (@AllowedClasses){
        _callIsAllowedClass($AllowedClasse,1);
    }
}
sub _negativTests{
    my @AllowedClasses = qw (
        LineItemProductXXX
        LineItemDepositXXX
        LineItemEcoParticipationXXX

        LineItemAppointmentXXX
        LineItemDiscountXXX
        LineItemPaymentDiscountXXX
        LineItemSalesDiscountXXX
        LineItemGlobalValueDiscountXXX
        LineItemCouponXXX

        xLineItemShipping
    );
    foreach my $AllowedClasse (@AllowedClasses){
        _callIsAllowedClass($AllowedClasse,0);
    }
}
sub _callIsAllowedClass{
    my $TestName = (caller(0))[3];
    my ($ClassName, $ExpectedResult) = @_;
    ## no critic (ProtectPrivateSubs )
    my $ReturnValue = DE_EPAGES::Billsafe::API::Common::_IsAnAllowedClass($ClassName);
    ## use critic (ProtectPrivateSubs )
    is( $ReturnValue, $ExpectedResult, "$TestName - is _IsAnAllowedClass($ClassName) == $ExpectedResult" );
}

RunScript( Sub => \&Main );